package eu.mhsl.craftattack.spawn.appliances.AntiSignEdit;

import eu.mhsl.craftattack.spawn.appliance.Appliance;
import eu.mhsl.craftattack.spawn.appliances.settings.Settings;
import eu.mhsl.craftattack.spawn.appliances.settings.datatypes.SelectSetting;
import eu.mhsl.craftattack.spawn.appliances.settings.settings.SignEditSetting;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import net.kyori.adventure.text.serializer.plain.PlainTextComponentSerializer;
import org.bukkit.block.sign.SignSide;
import org.bukkit.entity.Player;
import org.bukkit.event.Listener;
import org.jetbrains.annotations.NotNull;

import java.util.List;

public class AntiSignEdit extends Appliance {
    public boolean preventSignEdit(Player p, SignSide sign) {
        SelectSetting.Options.Option setting = Settings.instance().getSetting(p, Settings.Key.SignEdit, SelectSetting.Options.Option.class);
        if(setting.is(SignEditSetting.editable)) return false;
        if(setting.is(SignEditSetting.readOnly)) {
            p.sendActionBar(Component.text("Das Bearbeiten von Schildern ist in deinen Einstellungen deaktiviert.", NamedTextColor.RED));
            return true;
        }

        if(setting.is(SignEditSetting.editableWhenEmpty)) {
            boolean hasText = sign.lines().stream()
                .anyMatch(line -> !PlainTextComponentSerializer.plainText().serialize(line).isBlank());

            if(hasText) {
                p.sendActionBar(Component.text("Das Bearbeiten von Schildern, welch bereits beschrieben sind, ist bei dir deaktiviert.", NamedTextColor.RED));
                return true;
            }
        }

        return false;
    }

    @Override
    protected @NotNull List<Listener> eventHandlers() {
        return List.of(new OnSignEditListener());
    }
}
