package eu.mhsl.craftattack.spawn.appliances.hotbarRefill;

import eu.mhsl.craftattack.spawn.Main;
import eu.mhsl.craftattack.spawn.appliance.Appliance;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.bukkit.event.Listener;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.jetbrains.annotations.NotNull;

import java.util.List;
import java.util.NoSuchElementException;

public class HotbarRefill extends Appliance {
    public void handleHotbarChange(Player player, ItemStack item) {
        if (item.getAmount() != 1) return;
        Inventory inventory = player.getInventory();

        int itemSlot = inventory.first(item);
        if (itemSlot > 8) return;

        try {
            int replacementSlot = inventory.all(item.getType()).entrySet().stream()
                .filter(entry -> entry.getKey() > 8)
                .findFirst()
                .orElseThrow()
                .getKey();

            Bukkit.getScheduler().scheduleSyncDelayedTask(Main.instance(), () -> {
                ItemStack firstItem = inventory.getItem(itemSlot);
                ItemStack secondItem = inventory.getItem(replacementSlot);

                inventory.setItem(itemSlot, secondItem);
                inventory.setItem(replacementSlot, firstItem);

                player.sendActionBar(Component.text("Die Hotbar wurde aufgefüllt", NamedTextColor.GREEN));
            }, 1);
        } catch(NoSuchElementException ignored) {
            player.sendActionBar(Component.text("Keine weiteren Items dieser Art im Inventar vorhanden", NamedTextColor.RED));
        }
    }

    @Override
    protected @NotNull List<Listener> eventHandlers() {
        return List.of(new ItemRefillListener());
    }
}
