package eu.mhsl.craftattack.spawn.appliances.hotbarRefill;

import eu.mhsl.craftattack.spawn.appliance.ApplianceListener;
import eu.mhsl.craftattack.spawn.appliances.settings.Settings;
import org.bukkit.event.EventHandler;
import org.bukkit.event.block.BlockPlaceEvent;
import org.bukkit.event.player.PlayerItemBreakEvent;
import org.bukkit.event.player.PlayerItemConsumeEvent;
import org.bukkit.inventory.ItemStack;

public class ItemRefillListener extends ApplianceListener<HotbarRefill> {
    @EventHandler
    public void blockPlace(BlockPlaceEvent event) {
        if(!Settings.instance().getSetting(event.getPlayer(), Settings.Key.HotbarReplacer, Boolean.class)) return;

        ItemStack stackInHand = event.getItemInHand();
        if(stackInHand.getType().getMaxDurability() > 0) return;
        getAppliance().handleHotbarChange(event.getPlayer(), stackInHand);
    }

    @EventHandler
    public void onPlayerItemBreak(PlayerItemBreakEvent event) {
        if(!Settings.instance().getSetting(event.getPlayer(), Settings.Key.HotbarReplacer, Boolean.class)) return;

        getAppliance().handleHotbarChange(event.getPlayer(), event.getBrokenItem());
    }


    @EventHandler
    public void onPlayerItemConsume(PlayerItemConsumeEvent event) {
        if(!Settings.instance().getSetting(event.getPlayer(), Settings.Key.HotbarReplacer, Boolean.class)) return;

        getAppliance().handleHotbarChange(event.getPlayer(), event.getItem());
    }
}
