package eu.mhsl.craftattack.spawn.appliances.settings.listeners;

import eu.mhsl.craftattack.spawn.appliance.ApplianceListener;
import eu.mhsl.craftattack.spawn.appliances.settings.Settings;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.event.inventory.InventoryCloseEvent;

public class SettingsInventoryListener extends ApplianceListener<Settings> {
    @EventHandler
    public void onInventoryClick(InventoryClickEvent event) {
        Player player = (Player) event.getWhoClicked();
        if(getAppliance().hasSettingsNotOpen(player)) return;
        event.setCancelled(true);

        Settings.OpenSettingsInventory openInventory = getAppliance().getOpenInventory(player);
        openInventory.settings().stream()
            .filter(setting -> setting.buildItem().equals(event.getCurrentItem()))
            .findFirst()
            .ifPresent(setting -> {
                setting.triggerChange(player, event.getClick());
                openInventory.inventory().setItem(event.getSlot(), setting.buildItem());
            });
    }

    @EventHandler
    public void onInventoryClose(InventoryCloseEvent event) {
        getAppliance().onSettingsClose((Player) event.getPlayer());
    }
}
