package eu.mhsl.craftattack.spawn.util;

import org.bukkit.Bukkit;
import org.bukkit.GameRule;
import org.bukkit.World;
import org.bukkit.entity.Player;

import java.util.Map;
import java.util.function.Consumer;
import java.util.function.Function;

public class IteratorUtil {
    public static void worlds(Consumer<World> world) {
        worlds(w -> w, world);
    }

    public static <T> void worlds(Function<World, T> selector, Consumer<T> selected) {
        Bukkit.getWorlds().forEach(world -> selected.accept(selector.apply(world)));
    }

    public static void onlinePlayers(Consumer<Player> player) {
        Bukkit.getOnlinePlayers().forEach(player);
    }

    public static void setGameRules(Map<GameRule<Boolean>, Boolean> rules, boolean inverse) {
        rules.forEach((gameRule, value) -> IteratorUtil.worlds(world -> world.setGameRule(gameRule, value ^ inverse)));
    }
}
