package eu.mhsl.craftattack.spawn.util.server;

import org.bukkit.entity.Player;
import org.geysermc.floodgate.api.FloodgateApi;
import org.geysermc.floodgate.api.player.FloodgatePlayer;

import java.util.function.Consumer;

public class Floodgate {
    private static final FloodgateApi instance = FloodgateApi.getInstance();

    public static boolean isBedrock(Player p) {
        return instance.isFloodgatePlayer(p.getUniqueId());
    }

    public static FloodgatePlayer getBedrockPlayer(Player p) {
        return instance.getPlayer(p.getUniqueId());
    }

    public static void runBedrockOnly(Player p, Consumer<FloodgatePlayer> callback) {
        if(isBedrock(p)) callback.accept(instance.getPlayer(p.getUniqueId()));
    }

    public static void runJavaOnly(Player p, Consumer<Player> callback) {
        if(!isBedrock(p)) callback.accept(p);
    }
}
