package eu.mhsl.craftattack.spawn.util.text;

public class NumberAbbreviation {
    public static <T extends Number & Comparable<T>> String abbreviateNumber(T number) {
        double value = number.doubleValue();
        if(value >= 1_000_000) {
            return String.format("%.1fM", value / 1_000_000.0);
        } else if(value >= 1_000) {
            return String.format("%.1fk", value / 1_000.0);
        } else {
            return number.toString();
        }
    }

}
