package eu.mhsl.craftattack.spawn.util.text;

import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.TextColor;

import java.awt.*;

public class RainbowComponent {
    private int hueOffset = 0;
    private final String text;
    private final int density;
    private final int speed;

    public RainbowComponent(String text, int density, int speed) {
        this.text = text;
        this.density = density;
        this.speed = speed;
    }

    public Component getRainbowState() {
        Component builder = Component.empty();
        int hue = this.hueOffset;
        for(char c : text.toCharArray()) {
            TextColor color = TextColor.color(Color.getHSBColor((float) hue / 360, 1, 1).getRGB());
            builder = builder.append(Component.text(c).color(color));
            hue += density;
        }

        if(this.hueOffset > Byte.MAX_VALUE - speed) this.hueOffset = 0;
        this.hueOffset += (byte) speed;
        return builder;
    }
}
