package eu.mhsl.craftattack.spawn.util.world;

import org.bukkit.Location;
import org.bukkit.Material;

import java.util.List;

public class BlockCycle {
    private final Location location;
    private final Material defaultBlock;
    private final List<Material> blockList;
    private int current = 0;

    public BlockCycle(Location location, Material defaultBlock, List<Material> blockList) {
        this.location = location;
        this.defaultBlock = defaultBlock;
        this.blockList = blockList;
    }

    public void next() {
        location.getBlock().setType(blockList.get(current));
        current++;
        if(current >= blockList.size()) current = 0;
    }

    public void reset() {
        location.getBlock().setType(defaultBlock);
    }
}
