package eu.mhsl.craftattack.spawn.util.world;

import org.bukkit.Chunk;
import org.bukkit.Location;

public class ChunkUtils {
    public record ChunkPos(int x, int z) {
    }

    public static Chunk loadChunkAtLocation(Location location) {
        ChunkPos chunkPos = locationToChunk(location);
        return location.getWorld().getChunkAt(chunkPos.x, chunkPos.z);
    }

    public static ChunkPos locationToChunk(Location location) {
        return new ChunkPos(floor(location.x()) >> 4, floor(location.z()) >> 4);
    }

    private static int floor(double num) {
        int floor = (int) num;
        return floor == num ? floor : floor - (int) (Double.doubleToRawLongBits(num) >>> 63);
    }
}
